

//import java.util.*;



public class PasAPas extends Thread {
    
    public final static int MODE_CONTINU = 0;
    public final static int MODE_PAUSE = 1;
    public final static int MODE_PAS_A_PAS = 2;
    private int modeExecution;
    private int pause;
    private int temporisation = 1000;
    protected FenViewer viewer=null;


    public PasAPas () {
	
	modeExecution = MODE_PAS_A_PAS;
	pause=200;
    }
    
    synchronized public void pas() {
	notify();
    }

    public int getModeExecution() {
	return modeExecution;
    }

    public void setViewer(FenViewer fv){
	viewer=fv;
    }
    
    public void setModeExecution(int mode) {
	modeExecution=mode;
    }
    
    synchronized protected void pause(){
	
	switch(modeExecution)
	    {
	    case MODE_CONTINU:
		yield();
		break;
	    case MODE_PAUSE:
		break;
	    case MODE_PAS_A_PAS:
		try
		    {
			sleep(temporisation);
			if(viewer!=null)
			    {
				viewer.afficherContenu();
			    }
		    }
		catch(java.lang.InterruptedException e)
		    {
			System.out.println("(EEE) PasAPas : Erreur Sleep()");
		    }
		if(viewer!=null)
		    {
			viewer.afficherContenu();
		    }
		break;
	    default:
		System.out.println("(EEE) PasAPas : Erreur de switch");
	    }
    }
    
    
    synchronized protected void attendreEtapeSuivante() {
	
	switch(modeExecution)
	    {
	    case MODE_CONTINU:
		yield();
		break;
	    case MODE_PAUSE:
		try
		    {
			sleep(pause);
		    }
		catch(java.lang.InterruptedException e)
		    {
			System.out.println("(EEE) PasAPas : Erreur Sleep()");
		    }
		break;
	    case MODE_PAS_A_PAS:
		System.out.println("--- PAUSE ---");
		try
		    {
			wait();
		    }
		catch(java.lang.InterruptedException e)
		    {
			System.out.println("(EEE) PasAPas : Erreur Wait()");
		    }
		break;
	    default:
		System.out.println("(EEE) PasAPas : Erreur de switch");
	    }
    }
}

